import { RedBlackTreeImpl } from './red-black-tree';
import { BRANCH, Node } from './node';
import { PathNode } from './path';
export declare function rotateLeft<K, V>(upper: PathNode<K, V>, parent: Node<K, V>, child: Node<K, V>, tree: RedBlackTreeImpl<K, V>): Node<K, V>;
export declare function rotateRight<K, V>(upper: PathNode<K, V>, parent: Node<K, V>, child: Node<K, V>, tree: RedBlackTreeImpl<K, V>): Node<K, V>;
export declare function rotateLeftRight<K, V>(upper: PathNode<K, V>, grandParent: Node<K, V>, parent: Node<K, V>, child: Node<K, V>, tree: RedBlackTreeImpl<K, V>): Node<K, V>;
export declare function rotateRightLeft<K, V>(upper: PathNode<K, V>, grandParent: Node<K, V>, parent: Node<K, V>, child: Node<K, V>, tree: RedBlackTreeImpl<K, V>): Node<K, V>;
export declare function swapNodeContents<K, V>(upper: Node<K, V>, lower: Node<K, V>): void;
export declare function swapNodeColors<K, V>(upper: Node<K, V>, lower: Node<K, V>): void;
export declare function setChild<K, V>(branch: BRANCH, parent: Node<K, V>, child: Node<K, V>): void;
export declare function updateCount<K, V>(node: Node<K, V>): void;
